<?php
//---------------
/**
 * returns a svg with a fitting circle-cluster
 *
 * @param array $myArray
 * @param integer $iX - starting x-position
 * @param integer $iY - starting y-position
 * @param integer $iSize
 * @param integer $iDistance
 * @param string $sParent
 * @param integer $iIteration
 * @param integer $iMaxIteration
 * @return unknown
 */	
function clusterMe($myArray, $iX, $iY, $iSize, $iDistance, $sParent, $iIteration, $iMaxIteration) {
    $newRandom = round(rand());

    $sXML = "var groups$newRandom = document.createElementNS(svgNS, 'g');\n";	
	
    $aLength = sizeOf($myArray);
    $alpha = deg2rad(360/$aLength);
    $newRadius = 0;
    $oldRadius = 10;
    $i =0;	

    while (abs($oldRadius-$newRadius)>round($newRadius*0.05)&&i <=30) {
	    $i++;
    	$oldRadius = $newRadius;

	    $newXPos1   = $iX+round((($iSize/2)-$newRadius)*sin($alpha));
		$newYPos1   = $iY+round((($iSize/2)-$newRadius)*cos($alpha));
	    $newXPos2   = $iX+round((($iSize/2)-$newRadius)*sin(2*$alpha));
		$newYPos2   = $iY+round((($iSize/2)-$newRadius)*cos(2*$alpha));
		
		$newRadius = round(sqrt(pow(($newXPos2-$newXPos1),2)+pow(($newYPos2-$newYPos1),2))/2);
    }
    
	$sXML .= "var test = document.createElementNS(svgNS, 'line');\n";
	$sXML .= "$sParent.appendChild(test);";
	$sXML .= "test.setAttribute('x1','$newXPos1');\n";	
	$sXML .= "test.setAttribute('y1','$newYPos1');\n";
	$sXML .= "test.setAttribute('x2','$newXPos2');\n";
	$sXML .= "test.setAttribute('y2','$newYPos2');\n";
	$sXML .= "test.setAttribute('style','fill:none;stroke:#000000;stroke-width:1px;');\n";	
	
	
	
    
	$k = sqrt((1+cos($alpha))/2);

	//$newRadius = round(($iSize*$k)/(2*(1+$k)));
  	print("/*taslking about length|$aLength| and alpha |".(360/$aLength)."|*/");
	print("\n/* new radius|$newRadius| and k |$k| on size |$iSize|*/");	
	
	for ($i=0; $i < count($myArray); $i++) {

    	//echo $newRadius."-";
		
    	$newXPos   = $iX+round((($iSize/2)-$newRadius)*sin($i*$alpha));
		$newYPos   = $iY+round((($iSize/2)-$newRadius)*cos($i*$alpha));
      //$newRadius = round($iSize/30);
            
      $sXML .= "var group$i$newRandom = document.createElementNS(svgNS, 'g');\n";
      $sXML .= "group$i$newRandom.setAttribute('class','mapLayer$iIteration');\n";
      $sXML .= "groups$newRandom.appendChild(group".$i.$newRandom.");\n";
      $sXML .= $sParent.".appendChild(group".$i.$newRandom.");\n";
      
 /*     if (!is_array($myArray[$i])
          &&($iIteration < $iMaxIteration)) {
			  $sXML .= "var group".$i.$newRandom."image = document.createElementNS(svgNS, 'image');\n";
        $sXML .= "group".$i.$newRandom."image.setAttributeNS(xlinkNS,'href','img/products/".$myArray[$i]."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('id','".$myArray[$i]."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('class','prod_body');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('x','".($newXPos-44)."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('y','".($newYPos-44)."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('width','".round(160/$iIteration)."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('height','".round(160/$iIteration)."');\n";                               
        $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."image);\n";         
      }
*/
      $sXML .= "group$i$newRandom.setAttribute('id','group$i$newRandom');\n";      
      $sXML .= "var group".$i.$newRandom."circle = document.createElementNS(svgNS, 'circle');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('cx','$newXPos');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('cy','$newYPos');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('r','$newRadius');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('style','fill:none;stroke-width:0.5;stroke:black;');\n";
      $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."circle);\n";

      $sXML .= "var group".$i.$newRandom."line = document.createElementNS(svgNS, 'line');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('x1','$iX');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('y1','$iY');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('x2','$newXPos');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('y2','$newYPos');\n";            
      $sXML .= "group".$i.$newRandom."line.setAttribute('style','fill:none;stroke:black;stroke-width:0.5;');\n";
      $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."line);\n";         

			if (is_array($myArray[$i])
          &&($iIteration < $iMaxIteration))
			 $sXML .= clusterMe($myArray[$i], $newXPos, $newYPos, 2*$newRadius, $iDistance, "group".$i.$newRandom, $iIteration+1 , $iMaxIteration);

		} //FOR

	 return $sXML; 
  } //Function

  function clusterMeAsArray($myArray, $iX, $iY, $iSize, $iDistance, $sParent, $iIteration, $iMaxIteration) {
    $aLength = sizeOf($myArray);
   
    $newRandom = round(rand());
		$sXML = "var groups$newRandom = document.createElementNS(svgNS, 'g');\n";	
	$newArray = array();
    
	for ($i=0; $i < count($myArray); $i++) {
	  $uid = $myArray[$i];
      $newXPos   = $iX+round(($iSize/$iDistance)*sin(($i*(360/$aLength))/180 * pi()));
  	  $newYPos   = $iY+round(($iSize/$iDistance)*cos(($i*(360/$aLength))/180 * pi()));
      //$newRadius = round($iSize/30);
      $newRadius = round($iSize/3.1);
      
	  $newArray[$uid]["xpos"]= $newXPos-$newRadius;
	  $newArray[$uid]["ypos"]= $newYPos-$newRadius;
      
	  $newArray[$uid]["xsize"]= 2*$newRadius;
	  $newArray[$uid]["ysize"]= 2*$newRadius;
	  
	  
/*	  $sXML .= "var group$i$newRandom = document.createElementNS(svgNS, 'g');\n";
      $sXML .= "group$i$newRandom.setAttribute('class','mapLayer$iIteration');\n";
      $sXML .= "groups$newRandom.appendChild(group".$i.$newRandom.");\n";
      $sXML .= $sParent.".appendChild(group".$i.$newRandom.");\n";
*/      
      /*if (!is_array($myArray[$i])
          &&($iIteration < $iMaxIteration)) {
			  $sXML .= "var group".$i.$newRandom."image = document.createElementNS(svgNS, 'image');\n";
        $sXML .= "group".$i.$newRandom."image.setAttributeNS(xlinkNS,'href','img/products/".$myArray[$i]."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('id','".$myArray[$i]."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('class','prod_body');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('x','".($newXPos-44)."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('y','".($newYPos-44)."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('width','".round(160/$iIteration)."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('height','".round(160/$iIteration)."');\n";                               
        $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."image);\n";         
      }*/

/*$sXML .= "group$i$newRandom.setAttribute('id','group$i$newRandom');\n";      
      $sXML .= "var group".$i.$newRandom."circle = document.createElementNS(svgNS, 'circle');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('cx','$newXPos');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('cy','$newYPos');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('r','$newRadius');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('style','fill:none;stroke-width:0.5;stroke:black;');\n";
      $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."circle);\n";
*/

/*      $sXML .= "var group".$i.$newRandom."line = document.createElementNS(svgNS, 'line');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('x1','$iX');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('y1','$iY');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('x2','$newXPos');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('y2','$newYPos');\n";            
      $sXML .= "group".$i.$newRandom."line.setAttribute('style','fill:none;stroke:black;stroke-width:0.5;');\n";
      $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."line);\n";         
*/
      $newArray[$uid]["svg"]="<circle cx='$newXPos' cy='$newYPos' r='$newRadius' />";
	  if (is_array($myArray[$i])
          &&($iIteration < $iMaxIteration))
			 $newArray=array_merge($newArray,clusterMe($myArray[$i], $newXPos, $newYPos, round($iSize/3), $iDistance, "group".$i.$newRandom, $iIteration+1 , $iMaxIteration));

		} //FOR

	 return $newArray; 
  } //Function
  
?>
