/**
 * Ajax-Interface
 * 
 * Die hinterlegten Funktionen stellen die Verbindung zum Server dar. Die
 * Klasse class.vTnTModel.js greift auf die hier notierten funktionen zurueck.<b> 
 * 
 * Eine Implementierung als Klasse ist wg. Beschraenkungen innerhalb der prototypeJS- 
 * Bibliothek nicht mglich. 
 *
 * Es hlt die Ajax-Verbindung mit der Serverseite und pollt diese regelmaessig
 * nach Vernderungen.   
 * 
 * @author lray
 * @version 2007-02-20
 */
 
 function getUserData(source, timestamp, uid) {
         getPing(source, timestamp, uid);
	};
	
	
function getPing(source, timestamp, uid) {
	       	new Ajax.Request('index.php?eID=myext_ajax',
			  {
			    method:'get',
			    parameters: {			    	
			    	action: 	'ping', 
			    	timestamp: 	timestamp,
			    	uid:		uid
			    },
			    onSuccess: function(transport){
			      var response = transport.responseText || "no response text";
			      oLogger.debug("SuccessPing! \n\n"+transport.responseXML.documentElement.getElementsByTagName("user")[0].childNodes);
				
 			      var newTime =  transport.responseXML.documentElement.getElementsByTagName("time")[0].firstChild.data;
	          oLogger.info("timestamp: "+newTime);
	          source.setUTimestamp(newTime);

	          var userArray = transport.responseXML.documentElement.getElementsByTagName("user")[0].childNodes;
              //alert("userArray:"+userArray.length);
              
	            for ( var i = 0; i < userArray.length; i++) {
	                    if (userArray[i].nodeType != 1) {
	                    	continue;
	                    }
	                    
	                    var tmpUser = new User();
	                    
	                    oLogger.info("got user uid"+userArray[i].getElementsByTagName("id")[0].firstChild.data);
	                    tmpUser.setId(userArray[i].getElementsByTagName("id")[0].firstChild.data);
	                    tmpUser.setNick(userArray[i].getElementsByTagName("nick")[0].firstChild.data);
	                    tmpUser.setX(userArray[i].getElementsByTagName("xpos")[0].firstChild.data);
	                    tmpUser.setY(userArray[i].getElementsByTagName("ypos")[0].firstChild.data);
	                    tmpUser.setLoudness(userArray[i].getElementsByTagName("loudness")[0].firstChild.data);
	                    tmpUser.setActive(userArray[i].getElementsByTagName("chatter")[0].firstChild.data);
	
	                    tmpUser.setLastMoved(userArray[i].getElementsByTagName("lastmovedseconds")[0].firstChild.data);
	                    tmpUser.setLastSeen(userArray[i].getElementsByTagName("lmseconds")[0].firstChild.data);
	                    tmpUser.setLastAction(userArray[i].getElementsByTagName("laseconds")[0].firstChild.data);
	                    
	                    tmpUser.setName(userArray[i].getElementsByTagName("name")[0].firstChild.data);
	                    tmpUser.setCompany(userArray[i].getElementsByTagName("company")[0].firstChild.data);
	                    tmpUser.setPositionName(userArray[i].getElementsByTagName("cposition")[0].firstChild.data);
	                    tmpUser.setEmail(userArray[i].getElementsByTagName("email")[0].firstChild.data);
	                    
	                    //alert(userArray[i].getElementsByTagName("image").length);
	                    if (userArray[i].getElementsByTagName("image").length > 0) 
	                    {
	                    	tmpUser.setPicUrl(userArray[i].getElementsByTagName("image")[0].firstChild.data);
	                    }
	                    else 
	                    {
	                    	tmpUser.setPicUrl("fileadmin/anonym.jpg");
	                    }	       
	
	                    source.updateUser(tmpUser, true);
                                    
				    };
			
            /*source.notifyObservers(source.oObjects2BeNotifiedFor);
            source.clearNotifierCache();*/
            oLogger.info("observers notified.");
			    },
			    onFailure: function(){ oLogger.warn('Something went wrong...') }
			  });
}

function ajaxSetTextLine(source, uid, sId, x, y, loudness, text) {
	      
	       	new Ajax.Request('index.php?eID=myext_ajax',
			  {
			    method:'get',
			    parameters: {			    	
			    	action: 	'setTextLine', 
			    	sId: 	sId,
			    	x:		x,
			    	y:		y,
			    	loudness:loudness,
			    	text:	text
			    },
			    onSuccess: function(transport){
			      var response = transport.responseText || "no response text";
			      
			      oLogger.debug("Ajax:SuccessSetTextLine! \n\n" + response);
			      var newID = transport.responseXML.documentElement.getElementsByTagName("uid")[0].firstChild.data;

 			      if (source.getTextLineById(uid)) {
 			        source.getTextLineById(uid).setId(newID);
  			      oLogger.warn("textLine "+uid+" gefunden und ID angepasst."+source.getTextLineById(uid)+source.getTextLineById(newID));
              source.setLastTextMessage(newID);
  			    }
  			    else {
  			      oLogger.warn("Textline nicht wiedergefunden: uid "+uid+"sId "+sId+" newId "+newID);
  			    }
  			    /*source.notifyObservers(source.oObjects2BeNotifiedFor);*/

			    },
			    onFailure: function(){ alert('Something went wrong...') }
			  });
}

  function updateChat(source, textPositionX,textPositionY, movingDate, lastTextMessage){
	       	new Ajax.Request('index.php?eID=myext_ajax',
			  {
			    method:'get',
			    parameters: {			    	
			    	action: 	'updateChat', 
			    	textX: 		textPositionX,
			    	textY:		textPositionY,
			    	movingDate:	movingDate,
			    	lastTextMessage:lastTextMessage
			    },
			    onSuccess: function(transport){
			      var response = transport.responseText || "no response text";
			      var newTime =  transport.responseXML.documentElement.getElementsByTagName("time")[0].firstChild.data;
		          var chatArray = transport.responseXML.documentElement.getElementsByTagName("chat")[0].childNodes;
		            oLogger.info("chatarray:"+chatArray.length);
		            for ( var i = 0; i < chatArray.length; i++) {
		                    if (chatArray[i].nodeType != 1) {
				                    	continue;
				                    }
		                    var tmpTextLine = new TextLine();
		                    tmpTextLine.setId(chatArray[i].getElementsByTagName("id")[0].firstChild.data);
		                    tmpTextLine.setSId(chatArray[i].getElementsByTagName("sid")[0].firstChild.data);
		                    tmpTextLine.setX(chatArray[i].getElementsByTagName("xpos")[0].firstChild.data);
		                    tmpTextLine.setY(chatArray[i].getElementsByTagName("ypos")[0].firstChild.data);
		                    tmpTextLine.setLoudness(chatArray[i].getElementsByTagName("loudness")[0].firstChild.data);
		                    tmpTextLine.setTimestamp(chatArray[i].getElementsByTagName("timestamp")[0].firstChild.data); 
		                    tmpTextLine.setText(chatArray[i].getElementsByTagName("text")[0].firstChild.data);      
		                    oLogger.debug("got textline:"+tmpTextLine.getId());
		                    source.addTextLine(tmpTextLine, true);
                                           
		            };
            source.setTextTimestamp(Number(newTime-100));  
			    },
			    onFailure: function(){ alert('Something went wrong...') }
			  });
}

 function getProductMap(source, uid, xmin, ymin, xmax, ymax, iterationen, init){
	       	new Ajax.Request('index.php?eID=myext_ajax',
			  {
			    method:'get',
			    parameters: {			    	
			    	action: 	'getProductMap', 
			    	xmin: 	xmin,
			    	ymin:	ymin,
			    	xmax:   xmax,
			    	ymax:   ymax,
			    	iter:  	iterationen
			    },
			    onSuccess: function(transport){
			        var response = transport.responseText || "no response text";
		            var mapArray = transport.responseXML.documentElement.getElementsByTagName("map")[0].childNodes;

		            oLogger.info("maparray:"+mapArray.length);
		            var tmpProductList = source.getProducts();
		            for ( var i = 0; i < mapArray.length; i++) {
						// falls Element kein Knotenelement 		                    
	                    if (mapArray[i].nodeType != 1) { continue; };
	                    
	                    var tmpProduct = new Product();
	                    //alert("start with "+mapArray[i].getElementsByTagName("id")[0].firstChild.data);
	                    tmpProduct.setId(mapArray[i].getElementsByTagName("id")[0].firstChild.data);
                        tmpProduct.setName(mapArray[i].getElementsByTagName("name")[0].firstChild.data);	                    
                        tmpProduct.setPId(mapArray[i].getElementsByTagName("pid")[0].firstChild.data);                   
                        
                        //alert("vor svgeinfuegen");
                        tmpNodeContent = mapArray[i].getElementsByTagName("svg")[0].childNodes;

                        for ( var j=0; j < tmpNodeContent.length; j++) {
                          if (tmpNodeContent[j].nodeType == 1 ) {
                            tmpProduct.setNodeContent(tmpNodeContent[j]);
                            break;
                          }
                        }
		                //alert("nach svgeinfuegen");   
                        if (mapArray[i].getElementsByTagName("picurl")[0].childNodes.length > 0) { 
                          tmpProduct.setPicUrl("uploads/tx_lraypagestest/"+mapArray[i].getElementsByTagName("picurl")[0].firstChild.data);
                          }
	                    tmpProduct.setX(mapArray[i].getElementsByTagName("xpos")[0].firstChild.data);

	                    tmpProduct.setWidth(mapArray[i].getElementsByTagName("xsize")[0].firstChild.data);
	                    tmpProduct.setY(mapArray[i].getElementsByTagName("ypos")[0].firstChild.data);
	                    tmpProduct.setHeight(mapArray[i].getElementsByTagName("ysize")[0].firstChild.data);		                    
		                    
						//alert("got object "+mapArray[i].getElementsByTagName("id")[0].firstChild.data+" done");
                        if (Number(tmpProduct.getPId())>0 && tmpProductList.getProduct(tmpProduct.getPId()) instanceof Product) {
                          oLogger.info("ajax: Product "+ tmpProduct.getId()+ " an Product "+tmpProductList.getProduct(tmpProduct.getPId())+" angehaengt");
                          tmpProductList.getProduct(tmpProduct.getPId()).addItem(tmpProduct);
                        } else {  
                          tmpProductList.addItem(tmpProduct);
                          oLogger.info("ajax: Product "+ tmpProduct.getId()+ "("+tmpProduct.getPId()+") angehaengt");                          
                        }
                        //source.setProducts(tmpProductList);
		            };
            tmpProductList.updateProductTree();
            source.updateProducts();
            
            if (init != "undefined") {
            	var tmpProduct = tmpProductList.getProduct(source.getPageId());
            	
            	if (tmpProduct instanceof Product) {           		
            		if (tmpProduct.getLayer() == 0) source.setZoomLevel(0.3, true);
            		if (tmpProduct.getLayer() == 1) source.setZoomLevel(0.5, true);
            		if (tmpProduct.getLayer() == 2) source.setZoomLevel(1.0, true);
            		if (tmpProduct.getLayer() == 3) source.setZoomLevel(1.3, true);
            		if (tmpProduct.getLayer() == 4) source.setZoomLevel(1.6, true);
            		if (tmpProduct.getLayer() > 4)  source.setZoomLevel(1.8, true);
            	}
            };
            //alert("getProductMap: map angehaengt."+tmpProduct.getLayer());
            oLogger.info("getProductMap: map angehaengt.");
			    },
			    onFailure: function(){ alert('Something went wrong...') }
			  });
}


 	function ajaxGetPage(id){
	       	new Ajax.Request('index.php?id='+id+'&vtnt_pi1[noModules]=1&contentType=xml&L=0',
			  {
			    method:'get',
			    parameters: { },
			    onSuccess: function(transport){
			    var response = transport.responseXML || "no response text";
				
				var iframe = document.getElementById("iframe");
		
				// Depending on browser platform get the iframe's document, this is only
			    // available if the iframe has already been appended to an element which
			    // has been added to the document
			    if(iframe.contentDocument)
			      // Firefox, Opera
			      iframe.doc = iframe.contentDocument;
			    else if(iframe.contentWindow)
			      // Internet Explorer
			      iframe.doc = iframe.contentWindow.document;
			    else if(iframe.document)
			      // Others?
			      iframe.doc = iframe.document;
			    
			   while (iframe.doc.getElementsByTagName("html").length > 0)
					iframe.doc.removeChild(iframe.doc.getElementsByTagName("html")[0]);

				iframe.doc.appendChild(response.getElementsByTagName("html")[0].cloneNode(true));
				//iframe.doc=;
				//iframe.doc.=response;

			    },
			    onFailure: function(){ alert('Something went wrong...') }
			  });
}

    function ajaxSendUserToServer(source, uid, nick, x, y, loudness, active, name, company, position, pic) {
        oLogger.debug("ajaxSendUserToServer");
        ajax = new Ajax.Request('index.php?eID=myext_ajax',
			  {
			    method:'get',
			    parameters: {			    	
			    	action: 	'addUser', 
			    	  uid: 		uid, 
			        nick:		nick, 
			        x:			x, 
			        y:			y, 
			        loudness:	loudness, 
			        active:		active, 
			        name:		name, 
			        company:	company, 
			        position:	position, 
			        pic:		pic
			    },
			    onSuccess: function(transport){
			      var response = transport.responseText || "no response text";
			      var newID = transport.responseXML.documentElement.getElementsByTagName("uid")[0].firstChild.data;
			      if (source.getUserById(uid)) {
			          var tmpUser = source.getUserById(uid);
			          tmpUser.setId(newID);
			          source.addUser(tmpUser, true);
			          source.removeUser(uid);
  			      }
  			      oLogger.info("SuccessSendUserToServer! \n\n" + transport.responseXML.documentElement.getElementsByTagName("uid")[0].firstChild.data);
  			       //else oLogger.error("User-ID not changed, Leerlauf '.$id.'-'.$newID.'");');
			    },
			    onFailure: function(){ oLogger.warn('Something went wrong...') }
			  });

}
