<?php
header("Content-type:application/xhtml+xml");
require_once("area_library_2007_02_15.php");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de-DE">
  <head>
    <link rel="stylesheet" type="text/css" href="vTnT.css" />
    <title>JavaScript-OOP</title>
    <script type="text/javascript" src="litebox-1.0/js/prototype.js" onerror="alert('konnte prototype.js nicht laden');"></script>
    <script type="text/javascript" src="litebox-1.0/js/effects.js"   onerror="alert('konnte effects.js nicht laden');"></script>    
    <script type="text/javascript" src="class.Avatar.js"             onerror="alert('konnte class.Avatar.js nicht laden');"></script>
    <script type="text/javascript" src="class.AvatarCollection.js"   onerror="alert('konnte class.AvatarColelction.js nicht laden');"></script>    
    <script type="text/javascript" src="class.VisualMap.js"          onerror="alert('konnte class.VisualMap.js nicht laden');"></script>    
    <script type="text/javascript" src="class.TextLine.js"           onerror="alert('konnte class.TextLine.js nicht laden');"></script>
    <script type="text/javascript" src="class.TextLineCollection.js" onerror="alert('konnte class.TextLineCollection.js nicht laden');"></script>    
    <script type="text/javascript" src="src/js/log4js.js"            onerror="alert('konnte log4js.js nicht laden');"></script>
    <script language="javascript" src="litebox-1.0/js/md5.js"        onerror="alert('konnte md5.js nicht laden');"></script> 
    <script type="text/javascript"><![CDATA[

      //initialize the logger  with your category 
      var logger = Log4js.getLogger("vtntTest"); 
      //set the level of logging 
      logger.setLevel(Log4js.Level.ALL); 
      //set the Appender to write the log to 
      logger.addAppender(new ConsoleAppender(logger, true)); 

    // some facts
   	var svgNS = 'http://www.w3.org/2000/svg';
    var xhtmlNS = 'http://www.w3.org/1999/xhtml';
  	var xlinkNS = 'http://www.w3.org/1999/xlink';
    var iAktiveSeconds = 120;

// and get it to work   
    var myAvatar = new Avatar();
    myAvatar.setX(30);
    myAvatar.setY(20);    
    myAvatar.setId("moin");
  	myAvatar.setName("myName");
  	myAvatar.setActive(true);
  	myAvatar.setLoudness(40);
  	myAvatar.setOwn(true);
  	myAvatar.setLastAction("2006");
  	myAvatar.setLastMoved("2006-12-12");
  	myAvatar.setLastSeen("2006-12-12");

    var myAvatar2 = new Avatar();
    myAvatar2.setX(40);
    
    myAvatar2.setY(121);    
    myAvatar2.setId("main");
  	myAvatar2.setName("moesName");
  	myAvatar2.setNick("moe");
  	myAvatar2.setCompany("Moe Incorporated");
  	myAvatar2.setPositionName("COO");
  	myAvatar2.setPicUrl("http://www.l-ray.de/uploads/tx_templavoila/2002-11-05-LRay2_03.jpg");
  	myAvatar2.setActive(true);
  	myAvatar2.setLoudness(40);
  	myAvatar2.setOwn(false);
  	myAvatar2.setLastAction("2007");
  	myAvatar2.setLastMoved("2007-12-12");
  	myAvatar2.setLastSeen("2007-12-12");
    
    var aCol = new AvatarCollection();
    aCol.add(myAvatar);
    aCol.add(myAvatar2);
    
    var oVMap = new VisualMap();
    oVMap.setWidth("80");
    oVMap.setHeight("240");
    oVMap.add(aCol);  

// and the textline-area
    var myTextLine = new TextLine();
    myTextLine.setX(50);
    myTextLine.setY(50);
    myTextLine.setSId("sID1"),
    myTextLine.setId("ID1");
  	myTextLine.setText("erster dummer Kommentar");
  	myTextLine.setTimestamp(new Date().getTime());
 
    var myTextLine2 = new TextLine();
    myTextLine2.setX(60);
    myTextLine2.setY(60);
    myTextLine2.setSId("sID2"),
    myTextLine2.setId("ID2");
  	myTextLine2.setText("zweite, sinnvollere Version");
  	myTextLine2.setTimestamp(new Date().getTime());

    var aTLCol = new TextLineCollection();
    aTLCol.add(myTextLine);
    aTLCol.add(myTextLine2);
    
        var SVGDocument = null;
        var SVGRoot = null;
        
        var myTranslation = null;
        var myScale = null;
        var myTmpLoudness = null;        
        
        var TrueCoords = null;
        var Translation = null;
        var TranslationX = null;
        var TranslationY = null;
        var GrabPoint = null;
        var BackDrop = null;
        var DragTarget = null;
        var DragType = 1;
  
        function Init(evt)
        {
           logger.debug("SVG-Javascript inited");
           // SVGDocument = document.getElementById('vTnTMap').ownerDocument;
      		 // SVGRoot = evt.target;
      		 // SVGRoot = oVMap.paint();
           // these svg points hold x and y values...
           //    very handy, but they do not display on the screen (just so you know)
           TrueCoords = SVGRoot.createSVGPoint();
           GrabPoint = SVGRoot.createSVGPoint();
           // this will serve as the canvas over which items are dragged.
           //    having the drag events occur on the mousemove over a backdrop
           //    (instead of the dragged element) prevents the dragged element
           //    from being inadvertantly dropped when the mouse is moved rapidly
           BackDrop = SVGDocument.getElementById('BackDrop');
      }

      function Over(evt)
      {
         //logger.debug("mouse sended 'over'");
         var targetElement = evt.target;
         if (targetElement.getAttribute('class') == 'ava_body'
             && targetElement.parentNode.getAttribute('class') == 'avatar')

            aCol.detect( function(value) {
                return value.getId() == targetElement.parentNode.id;
            }).showUserData();
      }
      
      function Out(evt)
      {
         logger.debug("mouse sended 'out'");
         var targetElement = evt.target;
         //logger.debug("mouse sended 'out'");
         if (targetElement.getAttribute('class') == 'ava_body'
             && targetElement.parentNode.getAttribute('class') == 'avatar')
            aCol.detect( function(value) {
                return value.getId() == targetElement.parentNode.id;
            }).hideUserData();
      }

      function Grab(evt)
      {
         // find out which element we moused down on
         var targetElement = evt.target;
/*         SVGDocument.getElementById("mouseups").firstChild.data = "grabbed.";*/
          // der angewhlte Punkt ist der eigene Massepunkt
    		  if ((targetElement.getAttribute('class') == 'ava_body'
              &&targetElement.parentNode.getAttribute('class')
              &&targetElement.parentNode.getAttribute('class').match(/moveable/) ))
          { 
    		  	targetElement = aCol.detect( function(value) {
                return value.getId() == targetElement.parentNode.id;
            });

            logger.debug("grabbing "+evt.target.id+" for moving and got ");    		  	
            targetElement.setMovingType(1);
            DragType = 1;
    		  } else {
            // der gewhlte Punkt ist der eigene Umkreis 
            if (targetElement.getAttribute('class') == 'ava_loudness'
              &&targetElement.parentNode.getAttribute('class')
              &&targetElement.parentNode.getAttribute('class').match(/moveable/) ) {
    
          		  	targetElement = aCol.detect( function(value) {
                    return value.getId() == targetElement.parentNode.id;
                });
                targetElement.setMovingType(2);
    		  	    DragType = 2;
                logger.debug("grabbing "+evt.target.id+" for resizing.");                
              }
              else
                if (targetElement == SVGRoot) {
                
                }
                else targetElement = null;
          }
          
    		  //if ( targetElement == SVGRoot)
    		 	//  targetElement = null;

         if (targetElement == SVGRoot)
         {
            GrabPoint.x = TrueCoords.x;
            GrabPoint.y = TrueCoords.y; 
            logger.debug("grabbed Background");
            DragTarget = targetElement;       
         }
         
         // you cannot drag the background itself, so ignore any attempts to mouse down on it
         if ( targetElement != null && BackDrop != targetElement )
         {
            //set the item moused down on as the element to be dragged
            DragTarget = targetElement;
            DragTarget.setMovingType(DragType);

            // move this element to the "top" of the display, so it is (almost)
            //    always over other elements (exception: in this case, elements that are
            //    "in the folder" (children of the folder group) with only maintain
            //    hierarchy within that group
//            DragTarget.parentNode.appendChild( DragTarget );

            // turn off all pointer events to the dragged element, this does 2 things:
            //    1) allows us to drag text elements without selecting the text
            //    2) allows us to find out where the dragged element is dropped (see Drop)

            // we need to find the current position and translation of the grabbed element,
            //    so that we only apply the differential between the current location
            //    and the new location
            //var transMatrix = DragTarget.getCTM();
            //GrabPoint.x = TrueCoords.x - Number(transMatrix.e);
            //GrabPoint.y = TrueCoords.y - Number(transMatrix.f);
            GrabPoint.x = TrueCoords.x - DragTarget.getX();
            GrabPoint.y = TrueCoords.y - DragTarget.getY();
            myTmpLoudness = DragTarget.getLoudness();
         }
      };


      function Drag(evt)
      {
         // account for zooming and panning
         GetTrueCoords(evt);
         // if we don't currently have an element in tow, don't do anything
         // wir haben den Massepunkt
         if (DragTarget == SVGRoot) {
              var newX = TrueCoords.x - GrabPoint.x;
              var newY = TrueCoords.y - GrabPoint.y;
              oVMap.setTranslationX(Number(-1*newX));
              oVMap.setTranslationY(Number(-1*newY));          
              logger.debug("visualMap.setTranslation:"+newY+","+newX);
         }
         else {
            // wir haben den Body erwischt
           if (DragTarget&&DragTarget.getMovingType() == 1)
           {
              // account for the offset between the element's origin and the
              //    exact place we grabbed it... this way, the drag will look more natural
              var newX = TrueCoords.x - GrabPoint.x;
              var newY = TrueCoords.y - GrabPoint.y;
              var translation = SVGRoot.currentTranslate;
  
              // apply a new tranform translation to the dragged element, to display
              //    it in its new location
              DragTarget.setX(newX);
              DragTarget.setY(newY);
           }
  
            // wir haben den Umkreis
           if (DragTarget&&DragTarget.getMovingType() ==2)
           {
              // account for the offset between the element's origin and the
              //    exact place we grabbed it... this way, the drag will look more natural
              var newX = TrueCoords.x - GrabPoint.x - DragTarget.getX();
              var newY = TrueCoords.y - GrabPoint.y - DragTarget.getY();
              var newLoudness = Math.round( Math.sqrt( Math.pow(newX,2) + Math.pow(newY,2)));  
              // apply a new tranform translation to the dragged element, to display
              //    it in its new location
              logger.debug("Radius-Anpassung X:"+newX+" Y:"+newY+" ergibt "+newLoudness);              
              DragTarget.setLoudness(Number( myTmpLoudness + newLoudness ) );
           }
        }
      };


      function Drop(evt)
      {
         // if we aren't currently dragging an element, don't do anything
         if ( DragTarget )
         {
            // since the element currently being dragged has its pointer-events turned off,
            //    we are afforded the opportunity to find out the element it's being dropped on
            var targetElement = evt.target;
          
            // bewege Hintergrund
            if (DragTarget == SVGRoot) {
                DragTarget = null;
//                myTranslation = TrueCoords;
            }
            
            //genderter Radius
            if ( DragTarget.getMovingType() == 2 )
            {
/*               DragTarget.setAttributeNS(null, 'pointer-events', 'visibleStroke');*/
  
  /*          	 var aktTransform = DragTarget.parentNode.getAttributeNS(null,'transform');*/ 
  
               logger.debug(DragTarget.getId() + ' has now a changed Radius ' + targetElement.id 
               +' and has the following XY '+DragTarget.getX()+" "+DragTarget.getY());
              
                DragTarget.setMovingType(0);
                DragTarget.notify();
                DragTarget = null;
            }
            else
            if ( DragTarget.getMovingType() == 1 ){
                // turn the pointer-events back on, so we can grab this item later
               // for this example, you cannot drag an item out of the folder once it's in there;
               //    however, you could just as easily do so here

               logger.debug(DragTarget.getId() + ' has been dropped on top of ' + targetElement.id 
               +' and has the following XY '+DragTarget.getX()+","+DragTarget.getY());

              DragTarget.setMovingType(0);
              DragTarget.notify();
              DragTarget = null;
            } else
                DragTarget = null;
            // set the global variable to null, so nothing will be dragged until we
            //    grab the next element
         }
      };


      function GetTrueCoords(evt)
      {
         // find the current zoom level and pan setting, and adjust the reported
         //    mouse position accordingly

         var newScale = SVGRoot.currentScale;
         var translation = SVGRoot.currentTranslate;
         if ((DragTarget != SVGRoot)) {
           TrueCoords.x = ((evt.clientX - translation.x)/newScale);
           TrueCoords.y = ((evt.clientY - translation.y)/newScale);
         } else {
           TrueCoords.x = (evt.clientX);
           TrueCoords.y = (evt.clientY);
         }
         
         //logger.debug("Scale "+newScale+" Translation "+translation.x+","+translation.y+" with TrueCords "+TrueCoords.x+","+TrueCoords.y);
/*         SVGDocument.getElementById("mouseups").firstChild.data = "Cords= " + TrueCoords.x + " / " + TrueCoords.y;*/
      };

   ]]></script>

  </head>
  <body>
    <div id="vTnT">
      <div id="vTnTVisual"> 
        <script type="text/javascript"><![CDATA[
    
            document.getElementById('vTnTVisual').appendChild(oVMap.paint());  
            
            SVGRoot = oVMap.paint();
            TrueCoords =  oVMap.getSVGPoint();
            GrabPoint =   oVMap.getSVGPoint();
            BackDrop = oVMap.paint();  
            myTranslation = TrueCoords;      
    
    
      function doWithUser(what2do) {
        var tst =document.getElementById("vTnTMap").getAttribute("viewBox").split(" "); 
        switch (what2do) {
    /*      case "delete":    xajax_deleteAllUser();location.reload();
            break;
          case "ping":      pingMe(myAvatar);window.defaultStatus.value = "freshly pinged";
            break;
          case "dbupdate":  xajax_updateChat(myAvatar, active, lastMessage);window.defaultStatus.value = "textchat updated";
            break;
          case "maximize":  document.getElementById("vTnTMap").setAttribute("viewBox",tst[0]+" "+tst[1]+" "+Math.round(0.8*tst[2])+" "+Math.round(0.8*tst[3]));
                        break;   
          case "minimize":  document.getElementById("vTnTMap").setAttribute("viewBox",tst[0]+" "+tst[1]+" "+Math.round(1.2*tst[2])+" "+Math.round(1.2*tst[3]));
                        break;   
          case "left":  document.getElementById("vTnTMap").setAttribute("viewBox",(tst[0]-10)+" "+tst[1]+" "+tst[2]+" "+tst[3]);
                        break;   
          case "right": document.getElementById("vTnTMap").setAttribute("viewBox",(tst[0]+10)+" "+tst[1]+" "+tst[2]+" "+tst[3]);
                        break;   
          case "up":    document.getElementById("vTnTMap").setAttribute("viewBox",tst[0]+" "+(tst[1]-10)+" "+tst[2]+" "+tst[3]);
                        break;   
    
          case "down":  document.getElementById("vTnTMap").setAttribute("viewBox",tst[0]+" "+(tst[1]+10)+" "+tst[2]+" "+tst[3]);;
                        break;   
    
          case "norm":  document.getElementById("vTnTMap").setAttribute("viewBox","0 0 "+sizeMiniViewbox[0]+" "+sizeMiniViewbox[1]);
                        break;   
    */      case "mini":  
    /*                    document.getElementById("vTnTMap").setAttribute("viewBox",Math.round(getAvatarPosition(myAvatar)[0]- (sizeMiniViewbox[0] / 2))+" "
                          +Math.round(getAvatarPosition(myAvatar)[1]-(sizeMiniViewbox[1] / 2))+" "+sizeMiniViewbox[0]+" "+sizeMiniViewbox[1]);
                        SVGRoot = document.getElementById('vTnTMap').getSVGDocument().getElementsByTagName('svg');
                        SVGRoot.currentTranslate.x = Math.round(getAvatarPosition(myAvatar)[0]- (sizeMiniViewbox[0] / 2));
                        SVGRoot.currentTranslate.y = Math.round(getAvatarPosition(myAvatar)[1]-(sizeMiniViewbox[1] / 2));
    */
                        var vTnTName = "vTnT";
                        var vTnTBG = document.getElementById("vTnTBackground");
                        var vTnT =  document.getElementById(vTnTName);
                        var vTnTId = $("vTnTMapControl");
                        vTnTId.style.display = "none";
                        //$('vTnTChat').style.display = "none";
                        
                        vTnT.style.zIndex = 10000;
                        vTnT.style.width = "640px";
                        vTnT.style.position = "static";
                        oVMap.setWidth("80");
                        oVMap.setHeight("240");
                        
                        document.getElementById("vTnTVisual").style.width = "80px";
                        document.getElementById("vTnTVisual").style.height = "240px";
                        new Effect.Fade('vTnTBackground', { duration: 0.6, from: 0.8, to: 0.0 });

                        var tmpMyOwn = aCol.detect( function(item) {
                            return item.isOwn() == true;
                        });
                        
                        oVMap.setTranslationX(tmpMyOwn.getX()-40);                       
                        oVMap.setTranslationY(tmpMyOwn.getY()-120);
                        tmpMyOwn.setActive(false);
                        
                        $('vTnTChatInteraction').style.display = "block";
                        $("vTnTChat").setAttribute("class","minimized");
                        this.aTLCol.setLines2Show(1);
                        this.aTLCol.setTextLength(35);
                        this.aTLCol.setNameFilter(new Array("ID1"));
                        this.aTLCol.setTimestamp(new Date((new Date().getTime())-10000));
    
                        if (this.aTLCol.updateView() <= 0) {
                          $("vTnTChat").setAttribute("class","minimized and_closed");
                        }

                        break;   
    
          case "maxi":  
                        var pageSize = getPageSize();
                        var vTnTName = "vTnT";
                        var vTnTBG = $("vTnTBackground");
                        var vTnT =  $(vTnTName);
                        var vTnTId = $("vTnTMapControl");
                        
                        vTnT.style.zIndex = 10000;
                        vTnT.style.display = "none";
                        vTnT.style.width = "640px";

                        oVMap.setTranslationX(0);                       
                        oVMap.setTranslationY(0);

                        //vTnT.style.height = "480px";                        
                        vTnT.style.backgroundColor = "#ffffff";
                        vTnT.style.position = "absolute";
                        vTnT.style.padding = "20px 20px 20px 20px";

                        vTnTBG.style.width  = pageSize[0]+"px";
                        vTnTBG.style.height = pageSize[1]+"px";

                        vTnTId.style.display = "block";
                        $('vTnTChat').setAttribute("class","");
                        $('vTnTChatInteraction').style.display = "none";
                        oVMap.setWidth(620);
                        oVMap.setHeight(440);                  
                        document.getElementById("vTnTVisual").style.width = "600px";
                        document.getElementById("vTnTVisual").style.height = "440px";

                        new Effect.Appear('vTnTBackground', { duration: 0.6, from: 0.0, to: 0.8 });
                        vTnT.style.width = 660+"px";
                        vTnT.style.left = Number((pageSize[2] / 2)-320)+"px";        
                        vTnT.style.top = Number((pageSize[3] / 2)-300)+"px";
                        new Effect.Appear(vTnTName, { duration: 0.6, from: 0.0, to: 1.0 });    

                        var tmpMyOwn = aCol.detect( function(item) {
                            return item.isOwn() == true;
                        });
                        tmpMyOwn.setActive(true);
                        
                        this.aTLCol.setLines2Show(15);
                        this.aTLCol.setTextLength(-1);
                        this.aTLCol.setNameFilter(new Array());
    
                        $("vTnTChat").removeAttribute("class");
                        break;   
      
          default:
            debugLogger("doWithUser: unbekannte Aufforderung:"+what2do);
            break;
        }    
        
        function getPageSize(){
          	
          	var xScroll, yScroll;
          	
          	if (window.innerHeight && window.scrollMaxY) {	
          		xScroll = document.body.scrollWidth;
          		yScroll = window.innerHeight + window.scrollMaxY;
          	} else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
          		xScroll = document.body.scrollWidth;
          		yScroll = document.body.scrollHeight;
          	} else { // Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
          		xScroll = document.body.offsetWidth;
          		yScroll = document.body.offsetHeight;
          	}
          	
          	var windowWidth, windowHeight;
          	if (self.innerHeight) {	// all except Explorer
          		windowWidth = self.innerWidth;
          		windowHeight = self.innerHeight;
          	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
          		windowWidth = document.documentElement.clientWidth;
          		windowHeight = document.documentElement.clientHeight;
          	} else if (document.body) { // other Explorers
          		windowWidth = document.body.clientWidth;
          		windowHeight = document.body.clientHeight;
          	}	
          	
          	// for small pages with total height less then height of the viewport
          	if(yScroll < windowHeight){
          		pageHeight = windowHeight;
          	} else { 
          		pageHeight = yScroll;
          	}
          
          	// for small pages with total width less then width of the viewport
          	if(xScroll < windowWidth){	
          		pageWidth = windowWidth;
          	} else {
          		pageWidth = xScroll;
          	}
          	arrayPageSize = new Array(pageWidth,pageHeight,windowWidth,windowHeight) 
          	return arrayPageSize;
          }
    
     
      }


    function updateUserDetails() {
      var tmpMyOwn = aCol.detect( function(item) {
                            return item.isOwn() == true;
                        });
      tmpMyOwn.setNick($('nickInput').value);
      tmpMyOwn.setName($('nameInput').value);
      tmpMyOwn.setCompany($('companyInput').value);
      tmpMyOwn.setPositionName($('positionInput').value);
      tmpMyOwn.setEmail($('mailInput').value);
      tmpMyOwn.setPicUrl('http://www.gravatar.com/avatar.php?gravatar_id='+MD5($('mailInput').value));
      $('personalitiesPicture').setAttribute('src',tmpMyOwn.getPicUrl());
    }
         ]]></script>
    </div> <!-- vTNT-Visual -->
       <div id="vTnTChat">
          <div id="vTnTChatInput">
            <form id="vTnTInputForm" action="javascript:doSetChatline();"> 
            	<input type="text" id="vTnTInputFormInput" name="input" />
              <input type="submit" value="go" />
            </form>
          </div>
          <div id="vTnTChatInteraction">
            <ul title="possible interactions">
              <li><a href="javascript:showQuickNote();" title="zeigt Eingabefeld zur Quickl-Note an">schnellantwort</a></li>
              <li><a href="javascript:doWithUser('maxi');" title="wechselt in den groen Textchat-Modus">chatMode</a></li>
              <li><a href="javascript:clearMessage();" title="schliet diese Nachricht">ignorieren</a></li>
              <li><a href="javascript:window.close();" title="schliet den gesamten Chat">deaktivieren</a></li>
            </ul>
        </div>
      </div>
        <script type="text/javascript"><![CDATA[
    
            document.getElementById('vTnTChat').appendChild(aTLCol.paint());
            function doSetChatline() {
              var myTextLine = new TextLine();
              myTextLine.setX(50);
              myTextLine.setY(50);
              myTextLine.setSId("sID1"),
              myTextLine.setId("ID1");
            	myTextLine.setText($('vTnTInputFormInput').value);
            	myTextLine.setTimestamp(new Date());
            	aTLCol.add(myTextLine);
            	
              if ($('vTnTChat').getAttribute('class') == 'minimized') {
                aTLCol.setTimestamp(new Date());
                $('vTnTChat').setAttribute('class','minimized and_closed');
              }

              $('vTnTInputFormInput').value = "";            	        	

 	            aCol.detect( function(value) {
                return value.isOwn();
            }).setLastAction(new Date().getTime());
            }
            
            function showQuickNote() {
              document.getElementById('vTnTChatInput').setAttribute("class","visible");
              document.getElementById('vTnTInputFormInput').focus();
            } 

            function clearMessage() {
              $('vTnTChatOutput').removeChild(document.getElementById('vTnTChatOutput').firstChild);
              $('vTnTChat').setAttribute('class','minimized and_closed');
            }
            
            ]]></script>   

        <div id="vTnTAdmin">
          <button id="vTnTInputFormInput2"  name="input" title="manually repings data from server" onclick="doWithUser('ping');">Ping</button>	
          <button id="vTnTInputFormInput3"  name="input" title="manually checks for new messages" onclick="doWithUser('dbupdate');">CaD</button>
        	<button id="vTnTInputFormInput1"  name="input" title="deletes all user" onclick="doWithUser('delete');">DaU</button>
        	<button id="vTnTInputFormInput4"  name="input" title="decreases mapsize" onclick="doWithUser('minimize');">-</button>
        	<button id="vTnTInputFormInput5"  name="input" title="increases mapsize" onclick="doWithUser('maximize');">+</button>
        	<button id="vTnTInputFormInput6"  name="input" title="move left" onclick="doWithUser('left');">&lt;-</button>
        	<button id="vTnTInputFormInput7"  name="input" title="move right" onclick="doWithUser('right');">-&gt;</button>
        	<button id="vTnTInputFormInput8"  name="input" title="move up" onclick="doWithUser('up');">up</button>
        	<button id="vTnTInputFormInput9"  name="input" title="effect" onclick="new Effect.Appear('overlay', { duration: 0.2, from: 0.0, to: 0.8 });;">effect</button>
          <button id="vTnTInputFormInput10" name="input" title="go to portal-size" onclick="doWithUser('mini');">mini</button>	
          <button id="vTnTInputFormInput10" name="input" title="go to maximized size" onclick="doWithUser('maxi');">maxi</button>
       </div>

      <div id="vTnTMapControl">
          <form action="javascript:updateUserDetails();">
            <fieldset id="personalities">
              <img src="" id="personalitiesPicture" width="80" height="80" style="float: left;"/>
              <legend>Personalien</legend>
            	<label for="nickInput">Nickname</label>
            	<input type="text" value="" id="nickInput"  /> 
            	<label for="nameInput">Name</label>
            	<input type="text" value="" id="nameInput" /> 
            	<label for="companyInput">Firma</label>
            	<input type="text" value="" id="companyInput" /> 
            	<label for="positionInput">Position</label>
            	<input type="text" value="" id="positionInput" /> 
            	<label for="mailInput">E-Mail</label>
            	<input type="text" value="" id="mailInput" />
              <br /><input type="submit" value="okay" /> 
            </fieldset>
          </form>
        </div>
     </div>
    <div id="vTnTBackground" style="display: none; position: absolute; top:0px; left:0px; background-color:#000000; opacity: 0.8;"> </div>

  </body>
</html>
