<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Lennart Reuther <lennart_reuther@web.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once('class.tx_vtnt_db.php');
require_once('class.tx_vtnt_lib.php');

/**
 * Plugin 'vTnT' for the 'vtnt' extension.
 *
 * @author	Lennart Reuther <lennart_reuther@web.de>
 * @package	TYPO3
 * @subpackage	tx_lraysitemap
 */
class tx_vtnt_pi2 
{
	var $prefixId      = 'vtnt_pi2';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_vtnt_pi2.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'vtnt';	// The extension key.
	var $pi_checkCHash = true;
	
  var $cObj;
	
	var $db;	// Datasource
	
	/**
	 * identifying the user and the site he is on.
	 * 
	 * This function identifies the Session-ID used internally in typo3
	 * and the actual pid of the site being visited.
	 * 
	 * Both is being written into the tx_vtnt_sessions - table with imaginary
	 * coordinates corresponding with the product being viewed.               	 
	 *
	 * @author: LER
	 * @return	It's your decission
	 */
	function main($content, $conf)	{
    //echo "identUser";
    $db = t3lib_div::makeInstance('tx_vtnt_db');
    //$db = new tx_vtnt_db();
    $sessionId = $GLOBALS["TSFE"]->fe_user->id;
    $pageId = $GLOBALS["TSFE"]->id;
    
    $GLOBALS["TSFE"]->fe_user->setKey("ses", "pid", $GLOBALS["TSFE"]->id);
    $db->setVisitor($sessionId, $pageId); 
    //echo "user-ID".$GLOBALS["TSFE"]->id;
    return $content;
	}


}

?>
